"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const crypto = __importStar(require("crypto"));
// Inspired by drand48.
// Alternative way is crypto_rand_inc_exc(0, 2 ** 53) / 2 ** 53, but 2 ** 53 is greater than MAX_SAFE_INTEGER.
// See more: https://lemire.me/blog/2017/02/28/how-many-floating-point-numbers-are-in-the-interval-01/
// WARNING: If changing, ensure distribution remains uniform!
exports.default = () => {
    const out = Buffer.alloc(8);
    const rand = crypto.randomBytes(6);
    for (let i = 0; i < rand.length; i++) {
        out[i + 1] = out[i + 1] | (rand[i] >>> 4);
        out[i + 2] = out[i + 2] | (rand[i] << 4);
    }
    out[0] = 0x3f;
    out[1] |= 0xf0;
    return out.readDoubleBE(0) - 1.0;
};
