"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (areSame = (a, b) => a === b) => {
    let set = false;
    let value;
    let cached;
    return {
        map(v, computeIfChanged) {
            if (!set || !areSame(value, v)) {
                set = true;
                return (cached = computeIfChanged((value = v)));
            }
            return cached;
        },
    };
};
