"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assertType_1 = __importDefault(require("./assertType"));
const isArrayBuffer_1 = __importDefault(require("./isArrayBuffer"));
exports.default = (blob) => new Promise((resolve, reject) => {
    const reader = new FileReader();
    reader.readAsArrayBuffer(blob);
    reader.addEventListener("error", () => reject(reader.error));
    reader.addEventListener("load", () => resolve(assertType_1.default(reader.result, isArrayBuffer_1.default)));
});
