"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const bufferToUint8Array_1 = __importDefault(require("./bufferToUint8Array"));
const decodeBase64 = typeof Buffer == "function"
    ? (enc) => bufferToUint8Array_1.default(Buffer.from(enc, "base64"))
    : (enc) => Uint8Array.from(atob(enc), (c) => c.charCodeAt(0));
exports.default = decodeBase64;
