"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const arrayFromAsyncIterable_1 = __importDefault(require("./arrayFromAsyncIterable"));
const concatBuffers_1 = __importDefault(require("./concatBuffers"));
const isomorphicReadableStream_1 = __importDefault(require("./isomorphicReadableStream"));
exports.default = async (
// Node.js Buffer values are also JavaScript Uint8Array and TypedArray instances;
// see https://nodejs.org/api/buffer.html#buffer_buffers_and_typedarrays.
stream) => concatBuffers_1.default(await arrayFromAsyncIterable_1.default(isomorphicReadableStream_1.default(stream)));
